// csdn-updateDlg.h : header file
//

#pragma once
#include <map>


// CcsdnupdateDlg dialog
class CcsdnupdateDlg : public CDialog
{
// Construction
public:
	CcsdnupdateDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_CSDNUPDATE_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedStart();
	afx_msg void OnBnClickedStop();
	void SetClipBoardContent( std::string source );
	void PasteEvent();
	void CopyEvent();
	void ClickEvent( int x, int y );
	void GotoURL( std::string url );
	void UpdateProc( void );
	void GetWPlist( void );
	void GetCSDNlist( void );
	void ScrollDown();
	void SelectALL();
	bool VerifyReadPageLoaded();
	bool VerifyEditPageLoaded( std::string& );
	bool VerifySavePageLoaded( void );
	void Log( std::string& );
	static unsigned int __stdcall UpdateProcProxy( void* );
	void MonitorCursorProc( void );
	static unsigned int __stdcall MonitorCursorProcProxy( void* );

private:
	HANDLE m_hUpdateThread;
	HANDLE m_hMonitorThread;
	std::map<std::string, std::string> m_wplist;
	std::map<std::string, std::string> m_csdnlist;
	std::string m_hLogMessage;

	afx_msg void OnBnClickedButton3();
};
